<?php
/**
* Author: DragonFever
* Copyright: © 2010 DragonFever
* Website:  http://www.dragonfever.info
*/
 
// Disallow direct access to this file for security reasons
if(!defined("IN_MYBB"))
{
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}

// Plugin hook
$plugins->add_hook("member_profile_end", "cpfbbcode_action");

// Plugin info
function cpfbbcode_info()
{
	return array(
		"name"			=> "BBCode در فیلد های اختیاری",
		"description"	=> "این پلاگین اجازه استفاده از BBCode را در فیلد های اختیاری پروفایل می دهد، فارسی سازی توسط MyBBIran.com",
		"website"		=> "http://dragonfever.info",
		"author"		=> "DragonFever",
		"authorsite"	=> "http://dragonfever.info",
		"version"		=> "1.0",
		"guid" 			=> "0c3bb9829f363fdb2d5b4d6a8a25f60f",
		"compatibility" => "14*"
	);
}

// Activate plugin
function cpfbbcode_activate()
{
	global $db;

	$cpfbbcode_group = array(
		"gid"			=> "NULL",
		"name"			=> "cpfbbcode_settings",
		"title" 		=> "BBCode در فیلد های اختیاری",
		"description"	=> "تنظیمات برای BBCode در فیلد های اختیاری پروفایل.",
		"disporder"		=> "100",
		"isdefault"		=> "no",
	);
	$db->insert_query("settinggroups", $cpfbbcode_group);
	$gid = $db->insert_id();
	
	$settings[] = array(
		"sid"			=> "NULL",
		"name"			=> "cpfbbcode_allow_html",
		"title"			=> "اجازه اچ تی ام ال در فیلد های اختیاری",
		"description"	=> "آیا شما می خواهید اچ تی ام ال در فیلد های اختیاری استفاده شود؟",
		"optionscode"	=> "yesno",
		"value"			=> "0",
		"disporder"		=> "1",
		"gid"			=> intval($gid),
	);
	
	$settings[] = array(
		"sid"			=> "NULL",
		"name"			=> "cpfbbcode_allow_mycode",
		"title"			=> "اجازه مای کد در فیلد های اختیاری",
		"description"	=> "آیا شما می خواهید مای کد در فیلد های اختیاری استفاده شود؟",
		"optionscode"	=> "yesno",
		"value"			=> "1",
		"disporder"		=> "2",
		"gid"			=> intval($gid),
	);
	
	$settings[] = array(
		"sid"			=> "NULL",
		"name"			=> "cpfbbcode_allow_smilies",
		"title"			=> "اجازه شکلک در فیلد های اختیاری",
		"description"	=> "آیا شما می خواهید شکلک در فیلد های اختیاری استفاده شود؟",
		"optionscode"	=> "yesno",
		"value"			=> "1",
		"disporder"		=> "3",
		"gid"			=> intval($gid),
	);
	
	$settings[] = array(
		"sid"			=> "NULL",
		"name"			=> "cpfbbcode_allow_imgcode",
		"title"			=> "اجازه کد عکس در فیلد های اختیاری؟",
		"description"	=> "آیا شما می خواهید کد IMG در فیلد های اختیاری استفاده شود؟",
		"optionscode"	=> "yesno",
		"value"			=> "0",
		"disporder"		=> "4",
		"gid"			=> intval($gid),
	);
	
	$settings[] = array(
		"sid"			=> "NULL",
		"name"			=> "cpfbbcode_filter_badwords",
		"title"			=> "فیلتر کردن کلمه های بد در فیلد های اختیاری",
		"description"	=> "آیا شما می خواهید کلمه های بد را در فیلد های اختیاری فیلتر کنید؟",
		"optionscode"	=> "yesno",
		"value"			=> "1",
		"disporder"		=> "5",
		"gid"			=> intval($gid),
	);
	
	foreach($settings as $setting)
	{
		$db->insert_query("settings", $setting);
	}
	
	// Optimizing database
	$db->query("OPTIMIZE TABLE ".TABLE_PREFIX."settinggroups");
	$db->query("OPTIMIZE TABLE ".TABLE_PREFIX."settings");
	$db->query("OPTIMIZE TABLE ".TABLE_PREFIX."sessions");
	
	// Rebuilding settings
    rebuildsettings();
}

// Deactivate plugin
function cpfbbcode_deactivate()
{
	global $db;

	$db->query("DELETE FROM ".TABLE_PREFIX."settinggroups WHERE name='cpfbbcode_settings'");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='cpfbbcode_allow_html'");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='cpfbbcode_allow_mycode'");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='cpfbbcode_allow_smilies'");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='cpfbbcode_allow_imgcode'");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='cpfbbcode_filter_badwords'");
	
	// Optimizing database
	$db->query("OPTIMIZE TABLE ".TABLE_PREFIX."settinggroups");
	$db->query("OPTIMIZE TABLE ".TABLE_PREFIX."settings");
	$db->query("OPTIMIZE TABLE ".TABLE_PREFIX."sessions");
	
	// Rebuilding settings
    rebuildsettings();
}

// Run plugin
function cpfbbcode_action()
{
	global $db, $mybb, $lang, $templates, $parser, $theme, $userfields, $customfields, $profilefields, $field_hidden, $bgcolor, $alttrow;
	
	$customfields = '';
	$bgcolor = "trow1";
	$alttrow = "trow1";
	$query = $db->simple_select("profilefields", "*", "{$field_hidden}", array('order_by' => 'disporder'));
	while($customfield = $db->fetch_array($query))
	{
		$thing = explode("\n", $customfield['type'], "2");
		$type = trim($thing[0]);

		$field = "fid{$customfield['fid']}";
		$useropts = explode("\n", $userfields[$field]);
		$customfieldval = $comma = '';
		if(is_array($useropts) && ($type == "multiselect" || $type == "checkbox"))
		{
			foreach($useropts as $val)
			{
				if($val != '')
				{
					$customfieldval .= "<li style=\"margin-left: 0;\">{$val}</li>";
				}
			}
			if($customfieldval != '')
			{
				$customfieldval = "<ul style=\"margin: 0; padding-left: 15px;\">{$customfieldval}</ul>";
			}
		}
		else
		{
			if($customfield['type'] == "textarea")
			{
				$customfieldval = nl2br(htmlspecialchars_uni($userfields[$field]));
			}
			else
			{
				$customfieldval = htmlspecialchars_uni($userfields[$field]);
			}
		}
		
		// Set up the parser options.
		$parser_options = array(
			"allow_html" => $mybb->settings['cpfbbcode_allow_html'],
			"allow_mycode" => $mybb->settings['cpfbbcode_allow_mycode'],
			"allow_smilies" => $mybb->settings['cpfbbcode_allow_smilies'],
			"allow_imgcode" => $mybb->settings['cpfbbcode_allow_imgcode'],
			"filter_badwords" => $mybb->settings['cpfbbcode_filter_badwords']
		);

		$customfieldval = $parser->parse_message($customfieldval, $parser_options);
		$customfieldval = str_replace("&lt;br /&gt;", "", $customfieldval);
		
		eval("\$customfields .= \"".$templates->get("member_profile_customfields_field")."\";");
		$bgcolor = alt_trow();
	}
	if($customfields)
	{
		eval("\$profilefields = \"".$templates->get("member_profile_customfields")."\";");
	}
}
?>